--[[-- Script Information:
Mod:			           Zombie-Apocalypse|
Author: 				    playa slaya|
Version:				        [FINAL]|
Release: 				   08.11.2009|							
--  --  --  --  --  --  --  --  --  --  --  --  --  --  --  -- ]]

-----------------------
--  Setup             --
-----------------------
-- Initial Setup

function initArray(m)
	local array = {}
	for i = 1, m do
		array[i]=0
	end
	return array
end
-------
-- Game Setup

print("255255255Zombie - Apocalypse By: playa slaya")
parse("mp_freezetime 3")
parse("hud_fireinthehole 0")
parse("mp_killinfo 0")
parse("sv_gamemode 4")
parse("mp_wpndmg deagle 30")
parse("mp_wpndmg m3 60")
parse("mp_wpndmg xm1014 45")
parse("mp_wpndmg claw 0")
parse("mp_wpndmg deagle 36")
parse("mp_wpndmg mine 110")
parse("mp_wpndmg he 93")
parse('mp_wpndmg "Gut Bomb" 0')
parse('mp_wpndmg "Rocket Launcher" 315')
parse("mp_autoteambalance 0")
parse("mp_infammo 0")
parse("mp_zombierecover  1")
parse("sv_fow 1")
-------
-- Varible Setup
zm_scalps = initArray(32)
zm_lvl = initArray(32)
zm_exp = initArray(32)
hm_flesh = initArray(32)
hm_lvl = initArray(32)
hm_exp = initArray(32)
class = initArray(32)
hm_exp2l = initArray(32)
zm_exp2l = initArray(32)
zm_expgain = initArray(32)
hm_expgain = initArray(32)
hm_infects = initArray(32)
zm_infects = initArray(32)
zm_kills = initArray(32)

-------
-- Function Setup

function hudtext2(id,tid,color,txt,x,y)
	local toprint = (""..color.." "..txt)
	parse('hudtxt2 '..id..' '..tid..' "'..toprint..'" '..x.." "..y)
end
-------

function ZA_updatehud(id)
	parse('hudtxt2 '..id..' 1 " " 10 410')
	parse('hudtxt2 '..id..' 2 " " 255 425')
	parse('hudtxt2 '..id..' 3 " " 115 425')
	parse('hudtxt2 '..id..' 5 " " 10 410')
	parse('hudtxt2 '..id..' 4 " " 10 425')
	parse('hudtxt2 '..id..' 6 " " 255 425')
	parse('hudtxt2 '..id..' 7 " " 115 425')
	parse('hudtxt2 '..id..' 8 " " 10 425')
	if (player(id,"team")==1) then
		hudtext2(id,1,"107142035","Level: "..zm_lvl[id],10,410)
		hudtext2(id,2,"107142035","Class: "..class[id],10,425)
		hudtext2(id,3,"107142035","Exp: "..zm_exp[id].."/70",115,425)
		hudtext2(id,4,"107142035","Flesh: "..hm_flesh[id].."/500",255,425)
	elseif (player(id,"team")==2) then
		hudtext2(id,5,"107142035","Level: "..hm_lvl[id],10,410)
		hudtext2(id,6,"107142035","Class: "..class[id],10,425)
		hudtext2(id,7,"107142035","Exp: "..hm_exp[id].."/50",115,425)
		hudtext2(id,8,"107142035","Scalps: "..zm_scalps[id].."/500",255,425)
	end
end
-------

function ZA_updatehuds(source)
	parse('hudtxt2 '..source..' 1 " " 10 410')
	parse('hudtxt2 '..source..' 2 " " 255 425')
	parse('hudtxt2 '..source..' 3 " " 115 425')
	parse('hudtxt2 '..source..' 5 " " 10 410')
	parse('hudtxt2 '..source..' 4 " " 10 425')
	parse('hudtxt2 '..source..' 6 " " 255 425')
	parse('hudtxt2 '..source..' 7 " " 115 425')
	parse('hudtxt2 '..source..' 8 " " 10 425')
	if (player(source,"team")==1) then
		hudtext2(source,1,"107142035","Level: "..zm_lvl[source],10,410)
		hudtext2(source,2,"107142035","Class: "..class[source],10,425)
		hudtext2(source,3,"107142035","Exp: "..zm_exp[source].."/70",115,425)
		hudtext2(source,4,"107142035","Flesh: "..hm_flesh[source].."/500",255,425)
	elseif (player(source,"team")==2) then
		hudtext2(source,5,"107142035","Level: "..hm_lvl[source],10,410)
		hudtext2(source,6,"107142035","Class: "..class[source],10,425)
		hudtext2(source,7,"107142035","Exp: "..hm_exp[source].."/50",115,425)
		hudtext2(source,8,"107142035","Scalps: "..zm_scalps[source].."/500",255,425)
	end
end
-------

function toTable(t,match)
local cmd = {}
if not match then     match = "[^%s]+" end
for word in string.gmatch(t, match) do
table.insert(cmd, word) 
end 
return cmd 
end
-------

function ZA_save(id)
	if (player(id, "usgn") > 0) then
		file = assert(io.open("sys/lua/Zombie-Apocalypse/ZA_data/"..player(id, "usgn")..".txt","w"))
		file:write(zm_lvl[id].." "..zm_exp[id].." "..zm_expgain[id].." "..hm_flesh[id].." "..hm_lvl[id].." "..hm_exp[id].." "..hm_expgain[id].." "..zm_scalps[id].." "..hm_infects[id].." "..zm_infects[id].." "..zm_kills[id])
		file:close()
		msg2(id,'107142035Save Game Successfull!@C')
		else
			msg2(id,"255000000Please check your U.S.G.N account settings!@C")
	end
end
-------

function ZA_loadsave(id)
	usgn = player(id,"usgn")
	if (usgn > 0) then
		local usgn = player(id, "usgn")
		files = io.open("sys/lua/BlizzardDX/BDX_Data/SaveSlot03/"..usgn..".txt","r")
		if(files~=nil) then
			msg2(id,"107142035Your Last Save Loaded Successfully!@C")
			for line in io.lines("sys/lua/Zombie-Apocalypse/ZA_data/"..usgn..".txt","r") do
			local parses = toTable(line)
			if (tonumber(parses[1])>0) then
			zm_lvl[id] = tonumber(parses[1])
			zm_exp[id] = tonumber(parses[2])
			zm_expgain[id] = tonumber(parses[3])
			hm_flesh[id] = tonumber(parses[4])
			hm_lvl[id] = tonumber(parses[5])
			hm_exp[id] = tonumber(parses[6])
			hm_expgain[id] = tonumber(parses[7])
			zm_scalps[id] = tonumber(parses[8])
			hm_infects[id] = tonumber(parses[9])
			zm_infects[id] = tonumber(parses[10])
			zm_kills[id] = tonumber(parses[11])
		break
		end
	end
	else
		msg2(id,"255000000Failed to load save!@C")
	end
end
end
-------

function ZA_buyweapon_hm(id,weapon,cost,lvl)
	if (zm_scalps[id] >= cost) then
		if (hm_lvl[id] >= lvl) then
			zm_scalps[id] = zm_scalps[id] - cost
			parse("equip "..id.." "..weapon)
		else
			msg2(id,"255000000Not High Enough Level!@C")
			msg2(id,"107142035Your Level Must Be Level: "..lvl.." To Buy This Item!")
		end
	else
		msg2(id,"255000000Not Enough Scalps!@C")
		msg2(id,"107142035You Need "..cost.." Scalps To Buy This Item!")
	end
	ZA_updatehud(id)
end
-------

function ZA_sellflesh_hm(id,flesh,give)
	if (hm_flesh[id] >= flesh) then
		hm_flesh[id] = hm_flesh[id] - flesh
		zm_scalps[id] = zm_scalps[id] + give
		msg2(id,"107142035Transaction Complete!")
	else
		msg2(id,"255000000Not Enough Flesh For Trade!@C")
		msg2(id,"107142035You Need "..flesh.." To Trade!")
	end
	ZA_updatehud(id)
end
-------


-----------------------
--  Hooks             --
-----------------------
-- Join

addhook("join","ZA_join")
function ZA_join(id)
	zm_scalps[id] = 0
	zm_lvl[id] = 1
	zm_exp[id] = 0
	hm_flesh[id] = 0
	hm_lvl[id] = 1
	hm_exp[id] = 0
	zm_expgain[id] = 1
	hm_expgain[id] = 1
	class[id] = "???"
	ZA_loadsave(id)
	ZA_updatehud(id)
end
-------
-- Team

addhook("team","ZA_team")
function ZA_team(id,team)
	if (team == 1) then
		class[id] = "Zombie"
		ZA_updatehud(id)
		parse("equip "..id.." 78")
	end
	if (team == 2) then
		class[id] = "Human"
		ZA_updatehud(id)
	end
end
-------
-- Spawn

addhook("spawn","ZA_spawn")
function ZA_spawn(id)
	if (hm_lvl[id] < 1) then
		hm_lvl[id] = 1
	end
	if (zm_lvl[id] < 1) then
		zm_lvl[id] = 1
	end
	if (zm_lvl[id] < 30) then
		zm_expgain[id] = 1
	end
	if (hm_lvl[id] < 30) then
		hm_expgain[id] = 1
	end
	if (hm_flesh[id] > 500) then
		hm_flesh[id] = 500
	end
	if (zm_scalps[id] > 500) then
		zm_scalps[id] = 500
	end
	ZA_updatehud(id)
end
-------
-- Say
addhook("say","ZA_say")
function ZA_say(id,text)
	if (text == "!load") then
		ZA_loadsave(id)
	end
	if (text == "!save") then
		ZA_save(id)
	end
	if (text == "!reset") then
		zm_lvl[id] = 1
		zm_exp[id] = 0
		zm_expgain[id] = 1
		hm_flesh[id] = 0
		hm_lvl[id] = 1
		hm_exp[id] = 0
		hm_expgain[id] = 1
		zm_scalps[id] = 0
		msg2(id,"107142035Stats Have Been Reset!")
	end
	if (text == "!stats") then
		msg2(id,"107142035You Have Killed: "..zm_kills[id].." Zombies")
		msg2(id,"107142035You Have Infected: "..zm_infects[id].." People")
		msg2(id,"107142035You Have Been Infected: "..hm_infects[id].." Times")
	end
	if (text == "!cmds") then
		menu(id,"Say Commands List:,!load,!save,!reset,!stats,!cmds")
	end
	ZA_updatehud(id)
end
-- Hit

addhook("hit","ZA_hit")
function ZA_hit(id,source,weapon)
	if (weapon == 78) and (player(source,"team")==1) and (player(id,"team")==2) then
			parse("sv_sound \"player/zm_spray.wav\"")
			hm_infects[id] = hm_infects[id] + 1
			zm_infects[source] = zm_infects[source] + 1
			parse("customkill "..source.." Infected "..id)
			parse("spawnplayer "..id.." "..player(id,"x").." "..player(id,"y"))
			hm_flesh[source] = hm_flesh[source] + 2
			if (zm_expgain[source] == 1) then
				zm_exp[source] = zm_exp[source] + 10
			end
	end
	if (zm_exp[source] >= 70) and (player(source,"team")==1) then
		zm_lvl[source] = zm_lvl[source] + 1
		zm_exp[source] = 0
		msg2(source,"107142035Level Up!@C")
	end
	if (zm_lvl[source] >= 30) then
		zm_expgain[source] = 0
	end
	if (hm_flesh[id] > 500) then
		hm_flesh[id] = 500
	end
	ZA_updatehud(id)
	ZA_updatehuds(source)
end
-------
-- Kill

addhook('kill','ZA_kill')
function ZA_kill(id,weapon)
	if (player(id,"team") == 2) then
		if not (weapon == 78) then
		zm_kills[id] = zm_kills[id] + 1
		zm_scalps[id] = zm_scalps[id] + 1
			if (hm_expgain[id] == 1) then
				hm_exp[id] = hm_exp[id] + 10
			end
			if (hm_exp[id] >= 50) and (player(id,"team")==2) then
					hm_lvl[id] = hm_lvl[id] + 1
					hm_exp[id] = 0
					msg2(id,"107142035Level Up!@C")
			end
			if (hm_lvl[id] >= 30) then
				hm_expgain[id] = 0
			end
			if (zm_scalps[id] > 500) then
				zm_scalps[id] = 500
			end
		end
	end
	ZA_updatehud(id)
end
-------
-- Server Action

addhook("serveraction","ZA_serveraction")
function ZA_serveraction(id,action)
	if (action == 1) then
		if (player(id,"team")==2) then
			menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>")
		else
			msg2(id,"255000000You can not access this because of team!@C")
		end
	end
end
-------
-- Buy
addhook("buy","ZA_buy")
function ZA_buy()
	return 1
end
-------
-- Menu

addhook("menu","ZA_menu")
function ZA_menu(id,xmenu,select)
	if (xmenu == "Buy Menu") then
		if (select == 1) then menu(id,"Weapons Level 1,P228|$ 003,Deagle|$ 004,Elite|$ 004,Five-Seven|$ 005,Mac 10|$ 006,MP5|$ 007,UMP45|$ 007,Back <<") end
		if (select == 2) then menu(id,"Weapons Level 3-15,SG552  (3)|$ 009,Aug  (3)|$ 009,P90  (6)|$ 010,XM1014  (6)|$ 010,M3  (8)|$ 011,Galil  (12)|$ 011,Famas  (15)|$ 012,Back <<") end
		if (select == 3) then menu(id,"Weapons Level 20-30,M249 (20)|$ 015,Scout (20)|$ 018,AWP (22)|$ 019,Grenade Launcher (22)|$ 020,G3SG1 (22)|$ 020,FlameThrower (25)|$ 027,RPG (27)|$ 030,Rocket Launcher (30)|$ 050,Back <<") end
		if (select == 4) then menu(id,"Melee Weapons,Chainsaw |$ 013,Machete |$ 015,Back <<") end
		if (select == 5) then menu(id,"Miscellaneous  Page 1/2,Primary Ammo|$ 002,Secondary Ammo|$ 002,Flare|$ 001,Molotove Cocktail|$ 002,Gas Grenade|$ 002,Smoke Grenade|$ 002,Flashbang|$ 003,More >>,Back <<") end
		if (select == 6) then menu(id,"Trade Menu,Trade Flesh >>|"..hm_flesh[id]..",Back <<") end
		if (select == 7) then menu(id,"Save/Load Menu,Save Game,Load Game,Back <<") end
	end
	if (xmenu == "Weapons Level 1") then
		if (select == 1) then ZA_buyweapon_hm(id,4,3,1) end
		if (select == 2) then ZA_buyweapon_hm(id,3,4,1) end
		if (select == 3) then ZA_buyweapon_hm(id,5,4,1) end
		if (select == 4) then ZA_buyweapon_hm(id,6,5,1) end
		if (select == 5) then ZA_buyweapon_hm(id,23,6,1) end
		if (select == 6) then ZA_buyweapon_hm(id,20,7,1) end
		if (select == 7) then ZA_buyweapon_hm(id,24,7,1) end
		if (select == 8) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Weapons Level 3-15") then
		if (select == 1) then ZA_buyweapon_hm(id,31,9,3) end
		if (select == 2) then ZA_buyweapon_hm(id,33,9,3) end
		if (select == 3) then ZA_buyweapon_hm(id,22,10,6) end
		if (select == 4) then ZA_buyweapon_hm(id,11,10,6) end
		if (select == 5) then ZA_buyweapon_hm(id,10,11,8) end
		if (select == 6) then ZA_buyweapon_hm(id,38,11,12) end
		if (select == 7) then ZA_buyweapon_hm(id,39,11,15) end
		if (select == 8) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Weapons Level 20-30") then
		if (select == 1) then ZA_buyweapon_hm(id,40,15,20) end
		if (select == 2) then ZA_buyweapon_hm(id,34,18,20) end
		if (select == 3) then ZA_buyweapon_hm(id,35,19,22) end
		if (select == 4) then ZA_buyweapon_hm(id,49,20,22) end
		if (select == 5) then ZA_buyweapon_hm(id,36,20,22) end
		if (select == 6) then ZA_buyweapon_hm(id,46,27,25) end
		if (select == 7) then ZA_buyweapon_hm(id,47,30,27) end
		if (select == 8) then ZA_buyweapon_hm(id,48,50,30) end
		if (select == 9) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Melee Weapons") then
		if (select == 1) then ZA_buyweapon_hm(id,85,13,1) end
		if (select == 2) then ZA_buyweapon_hm(id,69,15,1) end
		if (select == 3) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Miscellaneous  Page 1/2") then
		if (select == 1) then ZA_buyweapon_hm(id,61,2,1) end
		if (select == 2) then ZA_buyweapon_hm(id,62,2,1) end
		if (select == 3) then ZA_buyweapon_hm(id,54,1,1) end
		if (select == 4) then ZA_buyweapon_hm(id,73,2,1) end
		if (select == 5) then ZA_buyweapon_hm(id,72,2,1) end
		if (select == 6) then ZA_buyweapon_hm(id,53,2,1) end
		if (select == 7) then ZA_buyweapon_hm(id,52,3,1) end
		if (select == 8) then menu(id,"Miscellaneous  Page 2/2,HE|$ 004,Kelvar|$ 004,Kelver+Helm|$006,Air-Strike|$010,Light Armor|$ 010,Armor|$ 012,Heavy Armor|$ 015,Back <<") end
		if (select == 9) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Miscellaneous  Page 2/2") then
		if (select == 1) then ZA_buyweapon_hm(id,51,4,1) end
		if (select == 2) then ZA_buyweapon_hm(id,57,4,1) end
		if (select == 3) then ZA_buyweapon_hm(id,58,6,1) end
		if (select == 4) then ZA_buyweapon_hm(id,76,10,1) end
		if (select == 5) then ZA_buyweapon_hm(id,79,10,1) end
		if (select == 6) then ZA_buyweapon_hm(id,80,12,1) end
		if (select == 7) then ZA_buyweapon_hm(id,81,15,1) end
		if (select == 8) then menu(id,"Miscellaneous  Page 1/2,Primary Ammo|$ 002,Secondary Ammo|$ 002,Flare|$ 001,Molotove Cocktail|$ 002,Gas Grenade|$ 002,Smoke Grenade|$ 002,Flashbang|$ 003,More >>,Back <<") end
	end
	if (xmenu == "Trade Menu") then
		if (select == 1) then menu(id,"Trade?,Trade  4,Cancle Transaction <<") end
		if (select == 2) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end
	if (xmenu == "Save/Load Menu") then
		if (select == 1) then ZA_save(id) end
		if (select == 2) then ZA_loadsave(id) end
		if (select == 3) then menu(id,"Buy Menu,Weapons Level 1 >>,Weapons Level 3-15 >>,Weapons Level 20-30 >>,Melee >>,Miscellaneous >>,Sell Flesh >>,Save/Load >>") end
	end	
	if (xmenu == "Trade?") then
		if (select == 1) then ZA_sellflesh_hm(id,4,1) end
		if (select == 2) then menu(id,"Trade Menu,Trade Flesh >>|"..hm_flesh[id]..",Back <<") end
	end
	ZA_updatehud(id)
end
-------
-- Minute

addhook("minute","ZA_minute")
function ZA_minute(id)
	msg("107142035Zombie - Apocalypse")
	msg("107142035Created by: playa slaya")
	msg("107142035Server Version: [FINAL]")
	msg("107142035Release Date: 08.11.2009")
end
-------
-- Leave

addhook("leave","ZA_leave")
function ZA_leave(id)
	ZA_save(id)
	zm_scalps[id] = 0
	zm_lvl[id] = 1
	zm_exp[id] = 0
	hm_flesh[id] = 0
	hm_lvl[id] = 1
	hm_exp[id] = 0
	zm_expgain[id] = 1
	hm_expgain[id] = 1
	class[id] = "???"
end
------~